#if !defined(PAIRCW_H)
#define PAIRCW_H

#include <stddef.h>			/* for size_t definition */
#include <deccw.h>

#if defined(__cplusplus)
extern "C" {
#endif

#if defined(__COMPILER_KCC__)
#define HAVE_SHORT_NAMES	1
#endif

#if defined(HAVE_SHORT_NAMES)
#define __STDC_VERSION__	0	/* to eliminate compiler warnings */
#include <shrtcw.h>
#endif /* defined(HAVE_SHORT_NAMES) */

typedef float float_pair[2];
typedef double double_pair[2];
typedef decimal_float decimal_float_pair[2];
typedef decimal_double decimal_double_pair[2];

/**********************************************************************/

extern const char * (poutf)	(/*@out@*/ char *, size_t, const char *, const float_pair);
extern float (pevalf)		(const float_pair);
extern float (phighf)		(const float_pair);
extern float (plowf)		(const float_pair);
extern int (pcmpf)		(const float_pair, const float_pair);
extern int (pilogbf)		(const float_pair);
extern int (pisinff)		(const float_pair);
extern int (pisnanf)		(const float_pair);
extern int (pisqnanf)		(const float_pair);
extern int (pissnanf)		(const float_pair);
extern int (psignbitf)		(const float_pair);
extern void (pabsf)		(/*@out@*/ float_pair, const float_pair);
extern void (pacosf)		(/*@out@*/ float_pair, const float_pair);
extern void (pacoshf)		(/*@out@*/ float_pair, const float_pair);
extern void (paddf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pasinf)		(/*@out@*/ float_pair, const float_pair);
extern void (pasinhf)		(/*@out@*/ float_pair, const float_pair);
extern void (patan2f)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (patanf)		(/*@out@*/ float_pair, const float_pair);
extern void (patanhf)		(/*@out@*/ float_pair, const float_pair);
extern void (pcbrtf)		(/*@out@*/ float_pair, const float_pair);
extern void (pconf)		(/*@out@*/ float_pair, int, const float [/* n */], const float);
extern void (pcopyf)		(/*@out@*/ float_pair, const float_pair);
extern void (pcopysignf)	(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pcosf)		(/*@out@*/ float_pair, const float_pair);
extern void (pcoshf)		(/*@out@*/ float_pair, const float_pair);
extern void (pcotanf)		(/*@out@*/ float_pair, const float_pair);
extern void (pdivf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pdotf)		(/*@out@*/ float_pair, int, const float [/* n */], const float [/* n */]);
extern void (pepsf)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp8f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp10f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp16f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp8m1f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp10m1f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp16m1f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp2f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexp2m1f)		(/*@out@*/ float_pair, const float_pair);
extern void (pexpf)		(/*@out@*/ float_pair, const float_pair);
extern void (pexpm1f)		(/*@out@*/ float_pair, const float_pair);
extern void (pfdimf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pfmaxf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pfminf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pfrexpf)		(/*@out@*/ float_pair, const float_pair, /*@out@*/ int *);
extern void (pfrexphf)		(/*@out@*/ float_pair, const float_pair, /*@out@*/ int *);
extern void (pfrexpof)		(/*@out@*/ float_pair, const float_pair, /*@out@*/ int *);
extern void (phypotf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pierfcf)		(/*@out@*/ float_pair, const float_pair);
extern void (pierff)		(/*@out@*/ float_pair, const float_pair);
extern void (pinf)		(/*@out@*/ float_pair, const char *, char **);
extern void (pinftyf)		(/*@out@*/ float_pair);
extern void (pipowf)		(/*@out@*/ float_pair, const float_pair, int);
extern void (pldexpf)		(/*@out@*/ float_pair, const float_pair, int);
extern void (pldexphf)		(/*@out@*/ float_pair, const float_pair, int);
extern void (pldexpof)		(/*@out@*/ float_pair, const float_pair, int);
extern void (plog101pf)		(/*@out@*/ float_pair, const float_pair);
extern void (plog161pf)		(/*@out@*/ float_pair, const float_pair);
extern void (plog1pf)		(/*@out@*/ float_pair, const float_pair);
extern void (plogf)		(/*@out@*/ float_pair, const float_pair);
extern void (plogbf)		(/*@out@*/ float_pair, const float_pair);
extern void (pmul2f)		(/*@out@*/ float_pair, float, float);
extern void (pmulf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (pnegf)		(/*@out@*/ float_pair, const float_pair);
extern void (pprosumf)		(/*@out@*/ float_pair, float, float, float, float);
extern void (pqnanf)		(/*@out@*/ float_pair, const char *);
extern void (_prdf)		(/*@out@*/ float_pair, const float_pair, float, const float_pair, const float_pair, /*@out@*/ int *);
extern void (pscalblnf)		(/*@out@*/ float_pair, const float_pair, long int n);
extern void (pscalbnf)		(/*@out@*/ float_pair, const float_pair, int n);
extern void (psetf)		(/*@out@*/ float_pair, float, float);
extern void (psinf)		(/*@out@*/ float_pair, const float_pair);
extern void (psinhf)		(/*@out@*/ float_pair, const float_pair);
extern void (psnanf)		(/*@out@*/ float_pair, const char *);
extern void (psplitf)		(/*@out@*/ float_pair, float);
extern void (psqrtf)		(/*@out@*/ float_pair, const float_pair);
extern void (psubf)		(/*@out@*/ float_pair, const float_pair, const float_pair);
extern void (psum2f)		(/*@out@*/ float_pair, float, float);
extern void (psumf)		(/*@out@*/ float_pair, int, const float [/* n */]);
extern void (ptanf)		(/*@out@*/ float_pair, const float_pair);
extern void (ptanhf)		(/*@out@*/ float_pair, const float_pair);

/**********************************************************************/

extern const char * (pout)	(/*@out@*/ char *, size_t, const char *, const double_pair);
extern double (peval)		(const double_pair);
extern double (phigh)		(const double_pair);
extern double (plow)		(const double_pair);
extern int (pcmp)		(const double_pair, const double_pair);
extern int (pilogb)		(const double_pair);
extern int (pisinf)		(const double_pair);
extern int (pisnan)		(const double_pair);
extern int (pisqnan)		(const double_pair);
extern int (pissnan)		(const double_pair);
extern int (psignbit)		(const double_pair);
extern void (pabs)		(/*@out@*/ double_pair, const double_pair);
extern void (pacos)		(/*@out@*/ double_pair, const double_pair);
extern void (pacosh)		(/*@out@*/ double_pair, const double_pair);
extern void (padd)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pasin)		(/*@out@*/ double_pair, const double_pair);
extern void (pasinh)		(/*@out@*/ double_pair, const double_pair);
extern void (patan)		(/*@out@*/ double_pair, const double_pair);
extern void (patan2)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (patanh)		(/*@out@*/ double_pair, const double_pair);
extern void (pcbrt)		(/*@out@*/ double_pair, const double_pair);
extern void (pcon)		(/*@out@*/ double_pair, int, const double [/* n */], const double);
extern void (pcopy)		(/*@out@*/ double_pair, const double_pair);
extern void (pcopysign)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pcos)		(/*@out@*/ double_pair, const double_pair);
extern void (pcosh)		(/*@out@*/ double_pair, const double_pair);
extern void (pcotan)		(/*@out@*/ double_pair, const double_pair);
extern void (pdiv)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pdot)		(/*@out@*/ double_pair, int, const double [/* n */], const double [/* n */]);
extern void (peps)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp8)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp10)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp16)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp8m1)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp10m1)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp16m1)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp2)		(/*@out@*/ double_pair, const double_pair);
extern void (pexp2m1)		(/*@out@*/ double_pair, const double_pair);
extern void (pexpm1)		(/*@out@*/ double_pair, const double_pair);
extern void (pfdim)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pfmax)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pfmin)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pfrexp)		(/*@out@*/ double_pair, const double_pair, /*@out@*/ int *);
extern void (pfrexph)		(/*@out@*/ double_pair, const double_pair, /*@out@*/ int *);
extern void (pfrexpo)		(/*@out@*/ double_pair, const double_pair, /*@out@*/ int *);
extern void (phypot)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pierf)		(/*@out@*/ double_pair, const double_pair);
extern void (pierfc)		(/*@out@*/ double_pair, const double_pair);
extern void (pin)		(/*@out@*/ double_pair, const char *, char **);
extern void (pinfty)		(/*@out@*/ double_pair);
extern void (pipow)		(/*@out@*/ double_pair, const double_pair, int);
extern void (pldexp)		(/*@out@*/ double_pair, const double_pair, int);
extern void (pldexph)		(/*@out@*/ double_pair, const double_pair, int);
extern void (pldexpo)		(/*@out@*/ double_pair, const double_pair, int);
extern void (plog)		(/*@out@*/ double_pair, const double_pair);
extern void (plog101p)		(/*@out@*/ double_pair, const double_pair);
extern void (plog161p)		(/*@out@*/ double_pair, const double_pair);
extern void (plog1p)		(/*@out@*/ double_pair, const double_pair);
extern void (plogb)		(/*@out@*/ double_pair, const double_pair);
extern void (pmul)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (pmul2)		(/*@out@*/ double_pair, double, double);
extern void (pneg)		(/*@out@*/ double_pair, const double_pair);
extern void (pprosum)		(/*@out@*/ double_pair, double, double, double, double);
extern void (pqnan)		(/*@out@*/ double_pair, const char *);
extern void (_prd)		(/*@out@*/ double_pair, const double_pair, double, const double_pair, const double_pair, /*@out@*/ int *);
extern void (pscalbln)		(/*@out@*/ double_pair, const double_pair, long int n);
extern void (pscalbn)		(/*@out@*/ double_pair, const double_pair, int n);
extern void (pset)		(/*@out@*/ double_pair, double, double);
extern void (psin)		(/*@out@*/ double_pair, const double_pair);
extern void (psinh)		(/*@out@*/ double_pair, const double_pair);
extern void (psnan)		(/*@out@*/ double_pair, const char *);
extern void (psplit)		(/*@out@*/ double_pair, double);
extern void (psqrt)		(/*@out@*/ double_pair, const double_pair);
extern void (psub)		(/*@out@*/ double_pair, const double_pair, const double_pair);
extern void (psum)		(/*@out@*/ double_pair, int, const double [/* n */]);
extern void (psum2)		(/*@out@*/ double_pair, double, double);
extern void (ptan)		(/*@out@*/ double_pair, const double_pair);
extern void (ptanh)		(/*@out@*/ double_pair, const double_pair);

/**********************************************************************/

#if defined(HAVE_LONG_DOUBLE)

typedef long double long_double_pair[2];

extern const char * (poutl)	(/*@out@*/ char *, size_t, const char *, const long_double_pair);
extern int (pcmpl)		(const long_double_pair, const long_double_pair);
extern int (pilogbl)		(const long_double_pair);
extern int (pisinfl)		(const long_double_pair);
extern int (pisnanl)		(const long_double_pair);
extern int (pisqnanl)		(const long_double_pair);
extern int (pissnanl)		(const long_double_pair);
extern int (psignbitl)		(const long_double_pair);
extern long double (pevall)	(const long_double_pair);
extern long double (phighl)	(const long_double_pair);
extern long double (plowl)	(const long_double_pair);
extern void (pabsl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pacoshl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pacosl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (paddl)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pasinhl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pasinl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (patan2l)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (patanhl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (patanl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pcbrtl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pconl)		(/*@out@*/ long_double_pair, int, const long double [/* n */], const long double);
extern void (pcopyl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pcopysignl)	(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pcoshl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pcosl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pcotanl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pdivl)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pdotl)		(/*@out@*/ long_double_pair, int, const long double [/* n */], const long double [/* n */]);
extern void (pepsl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp8l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp10l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp16l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp8m1l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp10m1l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp16m1l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp2l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexp2m1l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexpl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pexpm1l)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pfdiml)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pfmaxl)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pfminl)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pfrexpl)		(/*@out@*/ long_double_pair, const long_double_pair, /*@out@*/ int *);
extern void (pfrexphl)		(/*@out@*/ long_double_pair, const long_double_pair, /*@out@*/ int *);
extern void (pfrexpol)		(/*@out@*/ long_double_pair, const long_double_pair, /*@out@*/ int *);
extern void (phypotl)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pierfl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pierfcl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pinftyl)		(/*@out@*/ long_double_pair);
extern void (pinl)		(/*@out@*/ long_double_pair, const char *, char **);
extern void (pipowl)		(/*@out@*/ long_double_pair, const long_double_pair, int);
extern void (pldexpl)		(/*@out@*/ long_double_pair, const long_double_pair, int);
extern void (pldexphl)		(/*@out@*/ long_double_pair, const long_double_pair, int);
extern void (pldexpol)		(/*@out@*/ long_double_pair, const long_double_pair, int);
extern void (plog101pl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (plog161pl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (plog1pl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (plogbl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (plogl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pmul2l)		(/*@out@*/ long_double_pair, long double, long double);
extern void (pmull)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (pnegl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (pprosuml)		(/*@out@*/ long_double_pair, long double, long double, long double, long double);
extern void (pqnanl)		(/*@out@*/ long_double_pair, const char *);
extern void (_prdl)		(/*@out@*/ long_double_pair, const long_double_pair, long double, const long_double_pair, const long_double_pair, /*@out@*/ int *);
extern void (pscalblnl)		(/*@out@*/ long_double_pair, const long_double_pair, long int n);
extern void (pscalbnl)		(/*@out@*/ long_double_pair, const long_double_pair, int n);
extern void (psetl)		(/*@out@*/ long_double_pair, long double, long double);
extern void (psinhl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (psinl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (psnanl)		(/*@out@*/ long_double_pair, const char *);
extern void (psplitl)		(/*@out@*/ long_double_pair, long double);
extern void (psqrtl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (psubl)		(/*@out@*/ long_double_pair, const long_double_pair, const long_double_pair);
extern void (psum2l)		(/*@out@*/ long_double_pair, long double, long double);
extern void (psuml)		(/*@out@*/ long_double_pair, int, const long double [/* n */]);
extern void (ptanhl)		(/*@out@*/ long_double_pair, const long_double_pair);
extern void (ptanl)		(/*@out@*/ long_double_pair, const long_double_pair);

#endif /* defined(HAVE_LONG_DOUBLE) */

/**********************************************************************/

#if defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES)

/* NB: _FPWIDETYPES is set by the HP-UX IA-64 compilers in response to
   the -fpwidetypes command-line option, and  */

/* Mimic the HP-UX practice in <float.h>, <math.h>, and <stdlib.h> of
   providing typedefs of the user types extended and quad if they are
   not yet defined. */

#ifndef _INCLUDE_QUAD
typedef __float128 quad;
#define _INCLUDE_QUAD
#endif

#ifndef _INCLUDE_EXTENDED
typedef __float80 extended;
#define _INCLUDE_EXTENDED
#endif

typedef __float80 __float80_pair[2];
typedef __float80 extended_pair[2];

typedef __float128 __float128_pair[2];
typedef __float128 quad_pair[2];

extern __float80 (pevalw)	(const __float80_pair);
extern __float80 (phighw)	(const __float80_pair);
extern __float80 (ploww)	(const __float80_pair);
extern const char * (poutw)	(/*@out@*/ char *, size_t, const char *, const __float80_pair);
extern int (pcmpw)		(const __float80_pair, const __float80_pair);
extern int (pilogbw)		(const __float80_pair);
extern int (pisinfw)		(const __float80_pair);
extern int (pisnanw)		(const __float80_pair);
extern int (pisqnanw)		(const __float80_pair);
extern int (pissnanw)		(const __float80_pair);
extern int (psignbitw)		(const __float80_pair);
extern void (pabsw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pacoshw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pacosw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (paddw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pasinhw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pasinw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (patan2w)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (patanhw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (patanw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pcbrtw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pconw)		(/*@out@*/ __float80_pair, int, const __float80 [/* n */], const __float80);
extern void (pcopysignw)	(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pcopyw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pcoshw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pcosw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pcotanw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pdivw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pdotw)		(/*@out@*/ __float80_pair, int, const __float80 [/* n */], const __float80 [/* n */]);
extern void (pepsw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp8w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp10w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp16w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp8m1w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp10m1w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp16m1w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp2w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexp2m1w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexpm1w)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pexpw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pfdimw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pfmaxw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pfminw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pfrexpw)		(/*@out@*/ __float80_pair, const __float80_pair, /*@out@*/ int *);
extern void (pfrexphw)		(/*@out@*/ __float80_pair, const __float80_pair, /*@out@*/ int *);
extern void (pfrexpow)		(/*@out@*/ __float80_pair, const __float80_pair, /*@out@*/ int *);
extern void (phypotw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pierfcw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pierfw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pinftyw)		(/*@out@*/ __float80_pair);
extern void (pinw)		(/*@out@*/ __float80_pair, const char *, char **);
extern void (pipoww)		(/*@out@*/ __float80_pair, const __float80_pair, int);
extern void (pldexpw)		(/*@out@*/ __float80_pair, const __float80_pair, int);
extern void (pldexphw)		(/*@out@*/ __float80_pair, const __float80_pair, int);
extern void (pldexpow)		(/*@out@*/ __float80_pair, const __float80_pair, int);
extern void (plog101pw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (plog161pw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (plog1pw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (plogbw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (plogw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pmul2w)		(/*@out@*/ __float80_pair, __float80, __float80);
extern void (pmulw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (pnegw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (pprosumw)		(/*@out@*/ __float80_pair, __float80, __float80, __float80, __float80);
extern void (pqnanw)		(/*@out@*/ __float80_pair, const char *);
extern void (_prdw)		(/*@out@*/ __float80_pair, const __float80_pair, __float80, const __float80_pair, const __float80_pair, /*@out@*/ int *);
extern void (pscalblnw)		(/*@out@*/ __float80_pair, const __float80_pair, long int n);
extern void (pscalbnw)		(/*@out@*/ __float80_pair, const __float80_pair, int n);
extern void (psetw)		(/*@out@*/ __float80_pair, __float80, __float80);
extern void (psinhw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (psinw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (psnanw)		(/*@out@*/ __float80_pair, const char *);
extern void (psplitw)		(/*@out@*/ __float80_pair, __float80);
extern void (psqrtw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (psubw)		(/*@out@*/ __float80_pair, const __float80_pair, const __float80_pair);
extern void (psum2w)		(/*@out@*/ __float80_pair, __float80, __float80);
extern void (psumw)		(/*@out@*/ __float80_pair, int, const __float80 [/* n */]);
extern void (ptanhw)		(/*@out@*/ __float80_pair, const __float80_pair);
extern void (ptanw)		(/*@out@*/ __float80_pair, const __float80_pair);

/**********************************************************************/

extern __float128 (pevalq)	(const __float128_pair);
extern __float128 (phighq)	(const __float128_pair);
extern __float128 (plowq)	(const __float128_pair);
extern const char * (poutq)	(/*@out@*/ char *, size_t, const char *, const __float128_pair);
extern int (pcmpq)		(const __float128_pair, const __float128_pair);
extern int (pilogbq)		(const __float128_pair);
extern int (pisinfq)		(const __float128_pair);
extern int (pisnanq)		(const __float128_pair);
extern int (pisqnanq)		(const __float128_pair);
extern int (pissnanq)		(const __float128_pair);
extern int (psignbitq)		(const __float128_pair);
extern void (pabsq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pacoshq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pacosq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (paddq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pasinhq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pasinq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (patan2q)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (patanhq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (patanq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pcbrtq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pconq)		(/*@out@*/ __float128_pair, int, const __float128 [/* n */], const __float128);
extern void (pcopyq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pcopysignq)	(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pcoshq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pcosq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pcotanq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pdivq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pdotq)		(/*@out@*/ __float128_pair, int, const __float128 [/* n */], const __float128 [/* n */]);
extern void (pepsq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp8q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp10q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp16q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp8m1q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp10m1q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp16m1q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp2q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexp2m1q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexpm1q)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pexpq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pfdimq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pfmaxq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pfminq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pfrexpq)		(/*@out@*/ __float128_pair, const __float128_pair, /*@out@*/ int *);
extern void (pfrexphq)		(/*@out@*/ __float128_pair, const __float128_pair, /*@out@*/ int *);
extern void (pfrexpoq)		(/*@out@*/ __float128_pair, const __float128_pair, /*@out@*/ int *);
extern void (phypotq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pierfcq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pierfq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pinftyq)		(/*@out@*/ __float128_pair);
extern void (pinq)		(/*@out@*/ __float128_pair, const char *, char **);
extern void (pipowq)		(/*@out@*/ __float128_pair, const __float128_pair, int);
extern void (pldexpq)		(/*@out@*/ __float128_pair, const __float128_pair, int);
extern void (pldexphq)		(/*@out@*/ __float128_pair, const __float128_pair, int);
extern void (pldexpoq)		(/*@out@*/ __float128_pair, const __float128_pair, int);
extern void (plog101pq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (plog161pq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (plog1pq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (plogbq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (plogq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pmul2q)		(/*@out@*/ __float128_pair, __float128, __float128);
extern void (pmulq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (pnegq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (pprosumq)		(/*@out@*/ __float128_pair, __float128, __float128, __float128, __float128);
extern void (_prdq)		(/*@out@*/ __float128_pair, const __float128_pair, __float128, const __float128_pair, const __float128_pair, /*@out@*/ int *);
extern void (pqnanq)		(/*@out@*/ __float128_pair, const char *);
extern void (pscalblnq)		(/*@out@*/ __float128_pair, const __float128_pair, long int n);
extern void (pscalbnq)		(/*@out@*/ __float128_pair, const __float128_pair, int n);
extern void (psetq)		(/*@out@*/ __float128_pair, __float128, __float128);
extern void (psinhq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (psinq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (psnanq)		(/*@out@*/ __float128_pair, const char *);
extern void (psplitq)		(/*@out@*/ __float128_pair, __float128);
extern void (psqrtq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (psubq)		(/*@out@*/ __float128_pair, const __float128_pair, const __float128_pair);
extern void (psum2q)		(/*@out@*/ __float128_pair, __float128, __float128);
extern void (psumq)		(/*@out@*/ __float128_pair, int, const __float128 [/* n */]);
extern void (ptanhq)		(/*@out@*/ __float128_pair, const __float128_pair);
extern void (ptanq)		(/*@out@*/ __float128_pair, const __float128_pair);

#endif /* defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES) */

/**********************************************************************/

#if defined(HAVE_LONG_LONG_DOUBLE)

typedef long_long_double long_long_double_pair[2];

extern const char * (poutll)		(/*@out@*/ char *, size_t, const char *, const long_long_double_pair);
extern int (pcmpll)		(const long_long_double_pair, const long_long_double_pair);
extern int (pilogbll)		(const long_long_double_pair);
extern int (pisinfll)		(const long_long_double_pair);
extern int (pisnanll)		(const long_long_double_pair);
extern int (pisqnanll)		(const long_long_double_pair);
extern int (pissnanll)		(const long_long_double_pair);
extern int (psignbitll)		(const long_long_double_pair);
extern long_long_double (pevalll)	(const long_long_double_pair);
extern long_long_double (phighll)	(const long_long_double_pair);
extern long_long_double (plowll)	(const long_long_double_pair);
extern void (pabsll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pacoshll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pacosll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (paddll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pasinhll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pasinll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (patan2ll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (patanhll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (patanll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pcbrtll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pconll)		(/*@out@*/ long_long_double_pair, int, const long_long_double [/* n */], const long_long_double);
extern void (pcopyll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pcopysignll)	(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pcoshll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pcosll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pcotanll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pdivll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pdotll)		(/*@out@*/ long_long_double_pair, int, const long_long_double [/* n */], const long_long_double [/* n */]);
extern void (pepsll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp8ll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp10ll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp16ll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp8m1ll)	(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp10m1ll)	(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp16m1ll)	(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp2ll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexp2m1ll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexpll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pexpm1ll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pfdimll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pfmaxll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pfminll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pfrexpll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, /*@out@*/ int *);
extern void (pfrexphll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, /*@out@*/ int *);
extern void (pfrexpoll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, /*@out@*/ int *);
extern void (phypotll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pierfcll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pierfll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pinftyll)		(/*@out@*/ long_long_double_pair);
extern void (pinll)		(/*@out@*/ long_long_double_pair, const char *, char **);
extern void (pipowll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, int);
extern void (pldexpll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, int);
extern void (pldexphll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, int);
extern void (pldexpoll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, int);
extern void (plog101pll)	(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (plog161pll)	(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (plog1pll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (plogbll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (plogll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pmul2ll)		(/*@out@*/ long_long_double_pair, long_long_double, long_long_double);
extern void (pmulll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (pnegll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (pprosumll)		(/*@out@*/ long_long_double_pair, long_long_double, long_long_double, long_long_double, long_long_double);
extern void (_prdll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, long_long_double, const long_long_double_pair, const long_long_double_pair, /*@out@*/ int *);
extern void (pqnanll)		(/*@out@*/ long_long_double_pair, const char *);
extern void (pscalblnll)	(/*@out@*/ long_long_double_pair, const long_long_double_pair, long int n);
extern void (pscalbnll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, int n);
extern void (psetll)		(/*@out@*/ long_long_double_pair, long_long_double, long_long_double);
extern void (psinhll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (psinll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (psnanll)		(/*@out@*/ long_long_double_pair, const char *);
extern void (psplitll)		(/*@out@*/ long_long_double_pair, long_long_double);
extern void (psqrtll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (psubll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair, const long_long_double_pair);
extern void (psum2ll)		(/*@out@*/ long_long_double_pair, long_long_double, long_long_double);
extern void (psumll)		(/*@out@*/ long_long_double_pair, int, const long_long_double [/* n */]);
extern void (ptanhll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);
extern void (ptanll)		(/*@out@*/ long_long_double_pair, const long_long_double_pair);

#endif /* defined(HAVE_LONG_LONG_DOUBLE) */

/**********************************************************************/

#if defined(HAVE_DECIMAL)

extern const char * (poutdf)	(/*@out@*/ char *, size_t, const char *, const decimal_float_pair);
extern decimal_float (pevaldf)	(const decimal_float_pair);
extern decimal_float (phighdf)	(const decimal_float_pair);
extern decimal_float (plowdf)	(const decimal_float_pair);
extern int (pcmpdf)		(const decimal_float_pair, const decimal_float_pair);
extern int (pilogbdf)		(const decimal_float_pair);
extern int (pisinfdf)		(const decimal_float_pair);
extern int (pisnandf)		(const decimal_float_pair);
extern int (pisqnandf)		(const decimal_float_pair);
extern int (pissnandf)		(const decimal_float_pair);
extern int (psignbitdf)		(const decimal_float_pair);
extern void (pabsdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pacosdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pacoshdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (padddf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pasindf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pasinhdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (patan2df)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (patandf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (patanhdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pcbrtdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pcondf)		(/*@out@*/ decimal_float_pair, int, const decimal_float [/* n */], const decimal_float);
extern void (pcopydf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pcopysigndf)	(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pcosdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pcoshdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pcotandf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pdivdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pdotdf)		(/*@out@*/ decimal_float_pair, int, const decimal_float [/* n */], const decimal_float [/* n */]);
extern void (pepsdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp8df)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp10df)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp16df)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp8m1df)	(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp10m1df)	(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp16m1df)	(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp2df)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexp2m1df)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexpdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pexpm1df)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pfdimdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pfmaxdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pfmindf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pfrexpdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, /*@out@*/ int *);
extern void (pfrexphdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, /*@out@*/ int *);
extern void (pfrexpodf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, /*@out@*/ int *);
extern void (phypotdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pierfcdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pierfdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pindf)		(/*@out@*/ decimal_float_pair, const char *, char **);
extern void (pinftydf)		(/*@out@*/ decimal_float_pair);
extern void (pipowdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, int);
extern void (pldexpdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, int);
extern void (pldexphdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, int);
extern void (pldexpodf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, int);
extern void (plog101pdf)	(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (plog161pdf)	(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (plog1pdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (plogbdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (plogdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pmul2df)		(/*@out@*/ decimal_float_pair, decimal_float, decimal_float);
extern void (pmuldf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (pnegdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (pprosumdf)		(/*@out@*/ decimal_float_pair, decimal_float, decimal_float, decimal_float, decimal_float);
extern void (pqnandf)		(/*@out@*/ decimal_float_pair, const char *);
extern void (_prddf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, decimal_float, const decimal_float_pair, const decimal_float_pair, /*@out@*/ int *);
extern void (pscalblndf)	(/*@out@*/ decimal_float_pair, const decimal_float_pair, long int n);
extern void (pscalbndf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, int n);
extern void (psetdf)		(/*@out@*/ decimal_float_pair, decimal_float, decimal_float);
extern void (psindf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (psinhdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (psnandf)		(/*@out@*/ decimal_float_pair, const char *);
extern void (psplitdf)		(/*@out@*/ decimal_float_pair, decimal_float);
extern void (psqrtdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (psubdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair, const decimal_float_pair);
extern void (psum2df)		(/*@out@*/ decimal_float_pair, decimal_float, decimal_float);
extern void (psumdf)		(/*@out@*/ decimal_float_pair, int, const decimal_float [/* n */]);
extern void (ptandf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);
extern void (ptanhdf)		(/*@out@*/ decimal_float_pair, const decimal_float_pair);

/**********************************************************************/

extern const char * (poutd)	(/*@out@*/ char *, size_t, const char *, const decimal_double_pair);
extern decimal_double (pevald)	(const decimal_double_pair);
extern decimal_double (phighd)	(const decimal_double_pair);
extern decimal_double (plowd)	(const decimal_double_pair);
extern int (pcmpd)		(const decimal_double_pair, const decimal_double_pair);
extern int (pilogbd)		(const decimal_double_pair);
extern int (pisinfd)		(const decimal_double_pair);
extern int (pisnand)		(const decimal_double_pair);
extern int (pisqnand)		(const decimal_double_pair);
extern int (pissnand)		(const decimal_double_pair);
extern int (psignbitd)		(const decimal_double_pair);
extern void (pabsd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pacosd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pacoshd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (paddd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pasind)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pasinhd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (patan2d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (patand)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (patanhd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pcbrtd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pcond)		(/*@out@*/ decimal_double_pair, int, const decimal_double [/* n */], const decimal_double);
extern void (pcopyd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pcopysignd)	(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pcosd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pcoshd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pcotand)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pdivd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pdotd)		(/*@out@*/ decimal_double_pair, int, const decimal_double [/* n */], const decimal_double [/* n */]);
extern void (pepsd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp8d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp10d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp16d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp8m1d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp10m1d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp16m1d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp2d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexp2m1d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexpd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pexpm1d)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pfdimd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pfmaxd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pfmind)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pfrexpd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, /*@out@*/ int *);
extern void (pfrexphd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, /*@out@*/ int *);
extern void (pfrexpod)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, /*@out@*/ int *);
extern void (phypotd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pierfcd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pierfd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pind)		(/*@out@*/ decimal_double_pair, const char *, char **);
extern void (pinftyd)		(/*@out@*/ decimal_double_pair);
extern void (pipowd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, int);
extern void (pldexpd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, int);
extern void (pldexphd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, int);
extern void (pldexpod)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, int);
extern void (plog101pd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (plog161pd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (plog1pd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (plogbd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (plogd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pmul2d)		(/*@out@*/ decimal_double_pair, decimal_double, decimal_double);
extern void (pmuld)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (pnegd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (pprosumd)		(/*@out@*/ decimal_double_pair, decimal_double, decimal_double, decimal_double, decimal_double);
extern void (pqnand)		(/*@out@*/ decimal_double_pair, const char *);
extern void (_prdd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, decimal_double, const decimal_double_pair, const decimal_double_pair, /*@out@*/ int *);
extern void (pscalblnd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, long int n);
extern void (pscalbnd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, int n);
extern void (psetd)		(/*@out@*/ decimal_double_pair, decimal_double, decimal_double);
extern void (psind)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (psinhd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (psnand)		(/*@out@*/ decimal_double_pair, const char *);
extern void (psplitd)		(/*@out@*/ decimal_double_pair, decimal_double);
extern void (psqrtd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (psubd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair, const decimal_double_pair);
extern void (psum2d)		(/*@out@*/ decimal_double_pair, decimal_double, decimal_double);
extern void (psumd)		(/*@out@*/ decimal_double_pair, int, const decimal_double [/* n */]);
extern void (ptand)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);
extern void (ptanhd)		(/*@out@*/ decimal_double_pair, const decimal_double_pair);

/**********************************************************************/

#if defined(HAVE_DECIMAL_LONG_DOUBLE)

typedef decimal_long_double decimal_long_double_pair[2];

extern const char * (poutdl)	(/*@out@*/ char *, size_t, const char *, const decimal_long_double_pair);
extern decimal_long_double (pevaldl)		(const decimal_long_double_pair);
extern decimal_long_double (phighdl)		(const decimal_long_double_pair);
extern decimal_long_double (plowdl)		(const decimal_long_double_pair);
extern int (pcmpdl)		(const decimal_long_double_pair, const decimal_long_double_pair);
extern int (pilogbdl)		(const decimal_long_double_pair);
extern int (pisinfdl)		(const decimal_long_double_pair);
extern int (pisnandl)		(const decimal_long_double_pair);
extern int (pisqnandl)		(const decimal_long_double_pair);
extern int (pissnandl)		(const decimal_long_double_pair);
extern int (psignbitdl)		(const decimal_long_double_pair);
extern void (pabsdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pacosdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pacoshdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (padddl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pasindl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pasinhdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (patan2dl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (patandl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (patanhdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pcbrtdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pcondl)		(/*@out@*/ decimal_long_double_pair, int, const decimal_long_double [/* n */], const decimal_long_double);
extern void (pcopydl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pcopysigndl)	(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pcosdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pcoshdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pcotandl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pdivdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pdotdl)		(/*@out@*/ decimal_long_double_pair, int, const decimal_long_double [/* n */], const decimal_long_double [/* n */]);
extern void (pepsdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp8dl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp10dl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp16dl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp8m1dl)	(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp10m1dl)	(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp16m1dl)	(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp2dl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexp2m1dl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexpdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pexpm1dl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pfdimdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pfmaxdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pfmindl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pfrexpdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, /*@out@*/ int *);
extern void (pfrexphdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, /*@out@*/ int *);
extern void (pfrexpodl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, /*@out@*/ int *);
extern void (phypotdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pierfcdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pierfdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pindl)		(/*@out@*/ decimal_long_double_pair, const char *, char **);
extern void (pinftydl)		(/*@out@*/ decimal_long_double_pair);
extern void (pipowdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, int);
extern void (pldexpdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, int);
extern void (pldexphdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, int);
extern void (pldexpodl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, int);
extern void (plog101pdl)	(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (plog161pdl)	(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (plog1pdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (plogbdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (plogdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pmul2dl)		(/*@out@*/ decimal_long_double_pair, decimal_long_double, decimal_long_double);
extern void (pmuldl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (pnegdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (pprosumdl)		(/*@out@*/ decimal_long_double_pair, decimal_long_double, decimal_long_double, decimal_long_double, decimal_long_double);
extern void (pqnandl)		(/*@out@*/ decimal_long_double_pair, const char *);
extern void (_prddl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, decimal_long_double, const decimal_long_double_pair, const decimal_long_double_pair, /*@out@*/ int *);
extern void (pscalblndl)	(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, long int n);
extern void (pscalbndl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, int n);
extern void (psetdl)		(/*@out@*/ decimal_long_double_pair, decimal_long_double, decimal_long_double);
extern void (psindl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (psinhdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (psnandl)		(/*@out@*/ decimal_long_double_pair, const char *);
extern void (psplitdl)		(/*@out@*/ decimal_long_double_pair, decimal_long_double);
extern void (psqrtdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (psubdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair, const decimal_long_double_pair);
extern void (psum2dl)		(/*@out@*/ decimal_long_double_pair, decimal_long_double, decimal_long_double);
extern void (psumdl)		(/*@out@*/ decimal_long_double_pair, int, const decimal_long_double [/* n */]);
extern void (ptandl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);
extern void (ptanhdl)		(/*@out@*/ decimal_long_double_pair, const decimal_long_double_pair);

#endif /* defined(HAVE_DECIMAL_LONG_DOUBLE) */

/**********************************************************************/

#if defined(HAVE_DECIMAL_LONG_LONG_DOUBLE)

typedef decimal_long_long_double decimal_long_long_double_pair[2];

extern const char * (poutdll)		(/*@out@*/ char *, size_t, const char *, const decimal_long_long_double_pair);
extern decimal_long_long_double (pevaldll)		(const decimal_long_long_double_pair);
extern decimal_long_long_double (phighdll)		(const decimal_long_long_double_pair);
extern decimal_long_long_double (plowdll)		(const decimal_long_long_double_pair);
extern int (pcmpdll)		(const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern int (pilogbdll)		(const decimal_long_long_double_pair);
extern int (pisinfdll)		(const decimal_long_long_double_pair);
extern int (pisnandll)		(const decimal_long_long_double_pair);
extern int (pisqnandll)		(const decimal_long_long_double_pair);
extern int (pissnandll)		(const decimal_long_long_double_pair);
extern int (psignbitdll)	(const decimal_long_long_double_pair);
extern void (pabsdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pacosdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pacoshdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (padddll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pasindll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pasinhdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (patan2dll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (patandll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (patanhdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pcbrtdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pcondll)		(/*@out@*/ decimal_long_long_double_pair, int, const decimal_long_long_double [/* n */], const decimal_long_long_double);
extern void (pcopydll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pcopysigndll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pcosdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pcoshdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pcotandll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pdivdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pdotdll)		(/*@out@*/ decimal_long_long_double_pair, int, const decimal_long_long_double [/* n */], const decimal_long_long_double [/* n */]);
extern void (pepsdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp8dll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp10dll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp16dll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp8m1dll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp10m1dll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp16m1dll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp2dll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexp2m1dll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexpdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pexpm1dll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pfdimdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pfmaxdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pfmindll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pfrexpdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, /*@out@*/ int *);
extern void (pfrexphdll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, /*@out@*/ int *);
extern void (pfrexpodll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, /*@out@*/ int *);
extern void (phypotdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pierfcdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pierfdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pindll)		(/*@out@*/ decimal_long_long_double_pair, const char *, char **);
extern void (pinftydll)		(/*@out@*/ decimal_long_long_double_pair);
extern void (pipowdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, int);
extern void (pldexpdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, int);
extern void (pldexphdll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, int);
extern void (pldexpodll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, int);
extern void (plog101pdll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (plog161pdll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (plog1pdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (plogbdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (plogdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pmul2dll)		(/*@out@*/ decimal_long_long_double_pair, decimal_long_long_double, decimal_long_long_double);
extern void (pmuldll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pnegdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (pprosumdll)	(/*@out@*/ decimal_long_long_double_pair, decimal_long_long_double, decimal_long_long_double, decimal_long_long_double, decimal_long_long_double);
extern void (pqnandll)		(/*@out@*/ decimal_long_long_double_pair, const char *);
extern void (_prddll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, decimal_long_long_double, const decimal_long_long_double_pair, const decimal_long_long_double_pair, /*@out@*/ int *);
extern void (pscalblndll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, long int n);
extern void (pscalbndll)	(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, int n);
extern void (psetdll)		(/*@out@*/ decimal_long_long_double_pair, decimal_long_long_double, decimal_long_long_double);
extern void (psindll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (psinhdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (psnandll)		(/*@out@*/ decimal_long_long_double_pair, const char *);
extern void (psplitdll)		(/*@out@*/ decimal_long_long_double_pair, decimal_long_long_double);
extern void (psqrtdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (psubdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (psum2dll)		(/*@out@*/ decimal_long_long_double_pair, decimal_long_long_double, decimal_long_long_double);
extern void (psumdll)		(/*@out@*/ decimal_long_long_double_pair, int, const decimal_long_long_double [/* n */]);
extern void (ptandll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);
extern void (ptanhdll)		(/*@out@*/ decimal_long_long_double_pair, const decimal_long_long_double_pair);

#endif /* defined(HAVE_DECIMAL_LONG_LONG_DOUBLE) */

#endif /* defined(HAVE_DECIMAL) */

/**********************************************************************/

#if defined(__cplusplus)
}
#endif

#endif /* !defined(PAIRCW_H) */
